----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    07:18:05 01/27/2010 
-- Design Name: 
-- Module Name:    ntsc_TOP - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ntsc_TOP is
port(
out_0_led 	: out std_logic;
out_1_led 	: out std_logic;
clk		 	: in  std_logic;
reset			: in  std_logic;
composite_1v 	: out std_logic;
composite_0_5v	: out std_logic;
composite_0_3v	: out std_logic
);
end ntsc_TOP;

architecture Behavioral of ntsc_TOP is

type lineState		is (sFP,sHSYNC,sBP,sLINE);
type syncState		is (sIMAGE,sVSYNC);
type vbiState 		is (sPRE,sVERT,sPOST,sBLANK);
type fieldState	is	(sEVEN,sODD);

signal line_State 	: lineState  := sFP;
signal sync_State 	: syncState  := sIMAGE;
signal field_State	: fieldState := sEVEN;
signal vbi_State		: vbiState;

begin

process(clk,reset)
variable cnt : integer range 0 to 100000000 := 0;
variable ntsc_cnt : integer range 0 to 100000000 := 0;
begin
	if(reset = '0')then
	
	--Blink The Debug Leds 2Hz Frequency
	elsif(rising_edge(clk))then
		if(cnt = 49000000)then
			out_0_led <= '0';
			out_1_led <= '1';
		elsif(cnt = 99000000)then
			out_0_led <= '1';
			out_1_led <= '0';	
			cnt := 0;
		end if;
		
	cnt := cnt + 1;
	
	end if;
end process;

		--Begin NTSC Module

process(clk,reset)

--Bunch Of Variables For Counting Stuffs
variable lineTimer	: integer range 0 to 100000000 :=0;
variable resetTimer	: integer range 0 to 10 := 0;
variable line			: integer range 0 to 2000 := 0;
variable pixel			: integer range 0 to 2000 := 0;

variable odd			: integer range 0 to 1 := 0;

begin
if(reset = '0')then
	lineTimer := 0;
	resetTimer := 0;
elsif (rising_edge(clk)) then
	
	if (resetTimer = 1) then
		lineTimer := 0;
		resetTimer := 0;
		odd := odd+1;
	else
		lineTimer := lineTimer + 1;
	end if;	
	
	case sync_State is
	
	------------------------------
	-- image							 --
	------------------------------
	
	when sIMAGE =>
		
			case line_State is
			when sFP =>
				composite_1v 	<= '0';
				composite_0_5v	<= '0';					
				composite_0_3v	<= '1';			
				if (lineTimer >= 149) then --	// 1.5 us
					line_State <= sHSYNC;
					resetTimer := 1;
				end if;
		
			when sHSYNC =>
				composite_1v 	<= '0';
				composite_0_5v	<= '0';					
				composite_0_3v	<= '0';
				
				if (lineTimer >= 469) then--	// 4.7 us
					line_State <= sBP;
					resetTimer := 1;
					
					--// set up the pixel address
					pixel := 0;
					--//address = line * 263 + pixel;
				end if;
			when sBP =>
				composite_1v 	<= '0';
				composite_0_5v	<= '0';					
				composite_0_3v	<= '1';
				
				if (lineTimer >= 469) then --	// 4.7 us
					line_State <= sLINE;
					resetTimer := 1;
				end if;
			when sLINE =>		
				if (pixel < 263) then		
					
					--Create Chess Board
					if (line >= 30 and line < 70) or 
						(line >= 110 and line < 150) or 
						(line >= 190 and line < 230) or 
						(line >= 270 and line < 310) or 
						(line >= 350 and line < 390) then
						if pixel >= 40 and pixel < 60 then
							composite_1v 	<= '1';
							composite_0_5v	<= '0';
							composite_0_3v	<= '0';								
						elsif pixel >= 60 and pixel < 80 then
							composite_1v 	<= '0';
							composite_0_5v	<= '1';
							composite_0_3v	<= '0';								
						elsif pixel >= 80 and pixel < 100 then
							composite_1v 	<= '1';
							composite_0_5v	<= '0';
							composite_0_3v	<= '0';								
						elsif pixel >= 100 and pixel < 120 then
							composite_1v 	<= '0';
							composite_0_5v	<= '1';
							composite_0_3v	<= '0';								
						elsif pixel >= 120 and pixel < 140 then
							composite_1v 	<= '1';
							composite_0_5v	<= '0';
							composite_0_3v	<= '0';								
						elsif pixel >= 140 and pixel < 160 then
							composite_1v 	<= '0';
							composite_0_5v	<= '1';
							composite_0_3v	<= '0';								
						elsif pixel >= 160 and pixel < 180 then
							composite_1v 	<= '1';
							composite_0_5v	<= '0';
							composite_0_3v	<= '0';								
						elsif pixel >= 180 and pixel < 200 then
							composite_1v 	<= '0';
							composite_0_5v	<= '1';
							composite_0_3v	<= '0';								
						elsif pixel >= 200 and pixel < 220 then
							composite_1v 	<= '1';
							composite_0_5v	<= '0';
							composite_0_3v	<= '0';								
						elsif pixel >= 220 and pixel < 240 then
							composite_1v 	<= '0';
							composite_0_5v	<= '1';
							composite_0_3v	<= '0';				
						else
							composite_1v 	<= '1';
							composite_0_5v	<= '0';
							composite_0_3v	<= '0';
						end if;		
					elsif (line >= 70 and line < 110) or
							(line >= 150 and line < 190) or 
							(line >= 230 and line < 270) or 
							(line >= 310 and line < 350) or
							(line >= 390 and line < 430) then	
						if pixel >= 40 and pixel < 60 then
							composite_1v 	<= '0';
							composite_0_5v	<= '1';
							composite_0_3v	<= '0';								
						elsif pixel >= 60 and pixel < 80 then
							composite_1v 	<= '1';
							composite_0_5v	<= '0';
							composite_0_3v	<= '0';								
						elsif pixel >= 80 and pixel < 100 then
							composite_1v 	<= '0';
							composite_0_5v	<= '1';
							composite_0_3v	<= '0';								
						elsif pixel >= 100 and pixel < 120 then
							composite_1v 	<= '1';
							composite_0_5v	<= '0';
							composite_0_3v	<= '0';								
						elsif pixel >= 120 and pixel < 140 then
							composite_1v 	<= '0';
							composite_0_5v	<= '1';
							composite_0_3v	<= '0';								
						elsif pixel >= 140 and pixel < 160 then
							composite_1v 	<= '1';
							composite_0_5v	<= '0';
							composite_0_3v	<= '0';								
						elsif pixel >= 160 and pixel < 180 then
							composite_1v 	<= '0';
							composite_0_5v	<= '1';
							composite_0_3v	<= '0';								
						elsif pixel >= 180 and pixel < 200 then
							composite_1v 	<= '1';
							composite_0_5v	<= '0';
							composite_0_3v	<= '0';								
						elsif pixel >= 200 and pixel < 220 then
							composite_1v 	<= '0';
							composite_0_5v	<= '1';
							composite_0_3v	<= '0';												
						else
							composite_1v 	<= '1';
							composite_0_5v	<= '0';
							composite_0_3v	<= '0';							
						end if;					
					else
							composite_1v 	<= '1';
							composite_0_5v	<= '0';
							composite_0_3v	<= '0';						
					end if;
					
					if (lineTimer >= 19) then--	// 200 ns per pixel															
						pixel := pixel + 1;						
						resetTimer := 1;
					end if;
					
				else
					line := line + 2;
					line_State <= sFP;
					
					if (line >= 483) then
						sync_State <= sVSYNC;
						vbi_State <= sPRE;
						line := 0;
						resetTimer := 1;
					end if;
				end if;
			when others =>
			end case;

	------------------------------
	-- vertical synchronization --
	------------------------------	
	when sVSYNC =>
		case vbi_State is
			when sPRE =>
				case line_State is
					when sFP =>
						composite_1v 	<= '0';
						composite_0_5v	<= '0';							
						composite_0_3v	<= '1';
						
							if (lineTimer >= 149) then--	// 1.5 us
								line_State <= sLINE;
								resetTimer := 1;
							end if;
					when sLINE =>
						composite_1v 	<= '0';
						composite_0_5v	<= '0';							
						composite_0_3v	<= '0';
						
							if (lineTimer >= 3034) then --	// 63.5/2 - 1.4 us = 30.35us
								line_State <= sFP;
								resetTimer := 1;
								line := line + 1;
								if ((field_State = sEVEN and line >= 7) or (field_State = sODD and line >= 6)) then
									vbi_State <= sVERT;
									line := 0;
								end if;
							end if;
				when others =>
				end case;
		
			when sVERT =>
				case line_State is
					when sFP =>
						composite_1v 	<= '0';
						composite_0_5v	<= '0';							
						composite_0_3v	<= '1';
						
						if (lineTimer >= 2704) then--	// 63.5/2 - 4.7 us = 27.05us
							line_State <= sHSYNC;
							resetTimer := 1;
						end if;
					when sHSYNC =>
						composite_1v 	<= '0';
						composite_0_5v	<= '0';							
						composite_0_3v	<= '0';
						
						if (lineTimer >= 469)then--	// 4.7 us
							line_State <= sFP;
							resetTimer := 1;
							line := line + 1;
							
							if (line >= 6) then
								vbi_State <= sPOST;
								line := 0;
							end if;
						end if;
				when others =>
				end case;
		
			when sPOST =>
				case line_State is
					when sFP =>
						composite_1v 	<= '0';
						composite_0_5v	<= '0';							
						composite_0_3v	<= '1';
						
						if (lineTimer >= 149) then--	// 1.5 us
							line_State <= sLINE;
							resetTimer := 1;
						end if;
					when sLINE =>
						composite_1v 	<= '0';
						composite_0_5v	<= '0';						
						composite_0_3v	<= '0';
						
						if (lineTimer >= 3034) then--	// 63.5/2 - 1.4 us = 30.35us
							line_State <= sFP;
							resetTimer := 1;
							line := line + 1;
							
							if ((field_State = sEVEN and line >= 5) or (field_State = sODD and line >= 6)) then
								vbi_State <= sBLANK;
								line := 0;
							end if;
						end if;
					when others =>
					end case;
		
			when sBLANK =>
				case line_State is
					when sFP => 
						--signal = nSYNC;
						composite_1v 	<= '0';
						composite_0_5v	<= '0';						
						composite_0_3v	<= '0';
						
						if (lineTimer >= 469) then --		// 4.7 us
							line_State <= sLINE;
							resetTimer := 1;
						end if;
					
					when sLINE =>
						--signal = nBLACK;
						composite_1v 	<= '0';
						composite_0_5v	<= '0';						
						composite_0_3v	<= '1';
						
						if (lineTimer >= 5879) then --	// 63.5 - 4.7 us = 58.8us
							line_State <= sFP;
							resetTimer := 1;
							line := line + 1;
							
							if ((field_State = sEVEN and line >= 12) or (field_State = sODD and line >= 11)) then
								line_State <= sFP;
								sync_State <= sIMAGE;
									if field_State = sEVEN then
										field_State <= sODD;
											-- start on line 0 if sODD, line 1 if sEVEN
										line := 0;										
									else
										field_State <= sEVEN;
											-- start on line 1 if sEVEN
										line := 1;													
									end if;
							end if;
						end if;
					when others =>
					end case;
				when others =>
				end case;
		end case;
end if;
end process;

		--End NTSC Module

end Behavioral;